'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

exports.default = featureContent;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash.defaults');

var _lodash2 = _interopRequireDefault(_lodash);

var _reactRedux = require('react-redux');

var _reselect = require('reselect');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var babelPluginFlowReactPropTypes_proptype_Features = require('redux-features').babelPluginFlowReactPropTypes_proptype_Features || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_Feature = require('redux-features').babelPluginFlowReactPropTypes_proptype_Feature || require('prop-types').any;

function featureContent(options) {
  var _defaults = (0, _lodash2.default)({}, options, {
    getFeatures: function getFeatures(state) {
      return state ? state.features : {};
    },
    sortFeatures: function sortFeatures(features) {
      return (0, _values2.default)(features);
    }
  }),
      getFeatures = _defaults.getFeatures,
      sortFeatures = _defaults.sortFeatures,
      getContent = _defaults.getContent;

  var mapStateToProps = (0, _reselect.createStructuredSelector)({
    features: (0, _reselect.createSelector)(getFeatures, sortFeatures)
  });

  function mergeProps(_ref2, dispatchProps, _ref) {
    var features = _ref2.features;
    var children = _ref.children,
        props = (0, _objectWithoutProperties3.default)(_ref, ['children']);

    var content = [];
    features.forEach(function (feature, featureIndex) {
      var featureContent = getContent(feature);
      if (featureContent == null) return;
      if (typeof featureContent === 'function') featureContent = featureContent(props);
      if (!Array.isArray(featureContent)) featureContent = [featureContent];
      featureContent.forEach(function (item, index) {
        if (_react2.default.isValidElement(item) && item.key == null) {
          item = _react2.default.cloneElement(item, { key: featureIndex + ':' + index });
        }
        content.push(item);
      });
    });
    return {
      children: children instanceof Function ? children(content) : _react2.default.createElement(
        'div',
        null,
        content
      )
    };
  }

  mergeProps.propTypes = {
    features: require('prop-types').arrayOf(typeof babelPluginFlowReactPropTypes_proptype_Feature === 'function' ? babelPluginFlowReactPropTypes_proptype_Feature : require('prop-types').shape(babelPluginFlowReactPropTypes_proptype_Feature)).isRequired
  };
  var FeatureContent = function FeatureContent(_ref3) {
    var children = _ref3.children;
    return children;
  };

  return (0, _reactRedux.connect)(mapStateToProps, null, mergeProps)(FeatureContent);
}
featureContent.propTypes = {
  getFeatures: require('prop-types').func,
  sortFeatures: require('prop-types').func,
  getContent: require('prop-types').func.isRequired
};